Python Skriptsprache Tutorien

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Python scripting tutorial and the translation is 66% complete.

Outdated translations are marked like this.
Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎Bahasa Indonesia • ‎italiano • ‎日本語 • ‎polski • ‎português • ‎română • ‎русский • ‎Türkçe • ‎中文(中国大陆)‎

Base ExampleCommandModel.png Tutorial

Thema
Programming
Niveau
Intermediate
Zeit zum Abschluss
Autor
FreeCAD version
Beispieldatei(en)



Python ist eine Programmiersprache, sehr einfach zu bedienen und sehr schnell zu erlernen. Sie ist quelloffen, plattformübergreifend und kann für eine Vielzahl von Aufgaben allein verwendet werden, von der Programmierung einfacher Shell Skripte bis hin zu sehr komplexen Programmen. Aber eine der am weitesten verbreiteten Anwendungen ist die Skriptsprache, da sie leicht in andere Anwendungen integriert werden kann. Genau so wird es in FreeCAD verwendet. Von der Python Konsole oder von deinen benutzerdefinierten Skripten aus kannst du FreeCAD steuern und es sehr komplexe Aktionen ausführen lassen, für die es noch kein Werkzeug für die grafische Benutzeroberfläche gibt.

Zum Beispiel aus einem Python Skript, kannst Du:

  • neue Objekte erstellen
  • bestehende Objekte ändern
  • die 3D Darstellung dieser Objekte ändern
  • die FreeCAD Schnittstelle modifizieren

Es gibt auch mehrere Möglichkeiten, Python in FreeCAD zu verwenden:

  • Aus dem FreeCAD Python Interpreter, wo du einfache Befehle wie in einer "Kommandozeile" Stilschnittstelle ausgeben kannst.
  • Aus Makros, die eine bequeme Möglichkeit darstellen, ein fehlendes Werkzeug schnell zur FreeCAD Oberfläche hinzuzufügen.
  • Aus externen Skripten, mit denen man viel komplexere Dinge programmieren kann, wie z.B. ganze Arbeitsbereiche.

In diesem Tutorial werden wir an ein paar einfachen Beispielen arbeiten, um dir den Einstieg zu erleichtern, aber es gibt auch viel mehr zu diesem Thema Dokumentation über Python Skripting auf diesem Wiki. Wenn du völlig neu in Python bist und verstehen willst, wie es funktioniert, haben wir auch eine grundlegende Einführung in Python.

Wichtig! Bevor Sie mit dem Python scripting loslegen, sollten Sie noch zwei Ankreuzfelder im Menü Bearbeiten->Einstellungen->Allgemein->Ausgabefenster (ganz unten) aktivieren:

  • Interne Python-Meldungen auf Ausgabefenster umleiten
  • Interne Python-Fehlermeldungen auf Ausgabefenster umleiten

Gehen Sie dann ins Menü Ansicht->Paneele und klicken Sie auf Ausgabefenster. Dies wird Ihnen eine Menge Ärger ersparen.

Python-Code schreiben

Es gibt zwei einfache Wege, um Python-Programmcode in FreeCAD zu schreiben: Über die Python-Konsole (Menü: Ansicht->Paneele->Python-Konsole) oder über den Makro-Editor (Menü: Werkzeuge->Makros). In der Konsole werden die Python-Befehle zeilenweise nacheinander eingegeben und mit der Eingabetaste ausgeführt, wohingegen Makros komplexere Skripte enthalten können, die viele Zeilen lang sind und beim Ausführen des Makros nacheinander ausgeführt werden.

Die Python-Konsole in FreeCAD

In diesem Tutorial werden Sie beide Methoden kennenlernen, also entweder durch Kopieren/Einfügen von einzelnen Zeilen in die Python-Konsole und drücken der Eingabetaste oder alternativ durch Kopieren/Einfügen des gesamten Programmcodes in ein neues Makro-Fenster.

Erkunden von FreeCAD

Wir beginnen damit, ein neues und leeres Dokument zu erstellen:

doc = FreeCAD.newDocument()

Wenn Sie dies in die Python-Konsole eingeben, werden Sie bemerken, dass nach dem Eintippen von FreeCAD. ein neues Fenster erscheint, dass eine Autovervollständigung des gesuchten Befehls anbietet. Vorteilhaft ist dabei auch, dass jeder angebotene Befehl eine Kurzinfo über die Funktion des Befehls anzeigt, sobald man den Mauszeiger darüber stehen lässt. Dies macht es umso einfacher, die verschiedenen Möglichkeiten des Programms zu erkunden. Bevor Sie newDocument auswählen, sollten Sie sich auch die anderen verfügbaren Optionen ansehen.

Die Autovervollständigungsfunktion in der Python-Konsole von FreeCAD

Nach dem Drücken der Eingabetaste wird ein neues Dokument erzeugt. Dies ist vergleichbar mit dem Drücken der Schaltfläche Neues Dokument erstellen in der Werkzeugleiste. Tatsächlich wird beim Drücken von Schaltflächen in FreeCAD meistens lediglich ein Python-Code ausgeführt. Noch besser ist es, wenn man im Menü Bearbeiten->Einstellungen->Allgemein->Makro die Option Skript-Befehle in Pythonkonsole anzeigen aktiviert. Dadurch wird beim Drücken von Schaltflächen der dazugehörige Python-Code in der Konsole angezeigt, was das Erlernen der Python-Befehle erleichtert.

Kehren wir nun zu unserem Dokument zurück. Schauen wir uns an, was wir damit machen können:

doc.

Erkunden Sie die verfügbaren Möglichkeiten. Namen, die mit einem Großbuchstaben beginnen, bezeichnen üblicherweise Attribute (Variablen bzw. Eigenschaften), während Namen, die mit Kleinbuchstaben beginnen, meistens aufrufbaren Funktionen (so genannte "Methoden") kennzeichnen. Hingegen beziehen sich Namen, die mit einem Unterstrich beginnen, auf die interne Programmierung des Moduls und sind im Normalfall nicht für die Verwendung durch den Benutzer gedacht. Wir werden nun eine der verfügbaren Methoden nutzen, um ein neues Objekt in under Dokument einzufügen:

box = doc.addObject("Part::Box","myBox")

Es passiert zunächst einmal nichts. Warum? Weil FreeCAD für das große Ganze gedacht ist. Eines Tages wird es mit hunderten von komplexen Objekten arbeiten, die alle voneinander abhängen. Eine geringfügige Änderung an einer Stelle könnte eine große Veränderung an einer anderen Stelle bewirken, sodass das gesamte Dokument aufwendig neu berechnet werden muss. Aus diesem Grund aktualisiert kaum ein Befehl die Ansicht automatisch. Es muss manuell durchgeführt werden:

doc.recompute()

Nun erscheint unser Würfel. Viele der Schaltflächen für Objekte in FreeCAD tun eigentlich zwei Dinge: das Objekt einfügen und das Dokument neuberechnen lassen. Wenn Sie oben die Option Skript-Befehle in Pythonkonsole anzeigen aktiviert haben, dann können Sie dies nun leicht überprüfen, indem Sie die Schaltfläche für eine Kugel anklicken und sich anschließend die Ausgabekonsole ansehen, in der die beiden Befehle erscheinen sollten.

Was ist mit der "Part::Box", könnten Sie sich nun fragen? Woher kann ich wissen, welche anderen Objekte eingefügt werden können? Dies funktioniert mit folgendem Befehl:

doc.supportedTypes()

Nun erkunden wir die Inhalte unseres Würfels:

box.

Man sieht sofort einige interessante Dinge, wie z.B.:

box.Height

Dieser Befehl zeigt die aktuelle Höhe des Würfels an. Versuchen wir nun, diesen Wert zu ändern:

box.Height = 5

Wenn Sie den Würfel mit der Maus auswählen, dann sehen Sie in der Combo-Ansicht in der Registerkarte "Daten" ebenfalls diese Höhe. Alle Eigenschaften eines FreeCAD-Objektes, die dort erscheinen (und außerdem in der Registerkarte "Ansicht", später mehr dazu), können direkt über die Python-Konsole durch Angabe des Namens gelesen und geändert werden, genauso wie wir es mit der Höhe getan haben. Versuchen Sie die anderen Maße des Würfels auf diesem Wege zu ändern!

Vektoren und Platzierungen

Vektoren sind ein fester Bestandteil jeder 3D-Anwendung. Ein Vektor ist dabei eine Liste von Zahlen (x,y,z), die einen Ort im dreidimensionalen Raum beschreiben. Mit Vektoren sind verschiedene mathematische Operationen möglich, wie z.B. Addition, Subtraktion, Projektion (Skalarprodukt) und vieles mehr. In FreeCAD funktionieren Vektoren wie folgt:

myvec = FreeCAD.Vector(2,0,0)
myvec
myvec.x
myvec.y
othervec = FreeCAD.Vector(0,3,0)
sumvec = myvec.add(othervec)

Ein wichtiges Merkmal von Objekten in FreeCAD ist ihr Ort. Jedes Objekt besitzt Attribute, die seinen Ort (Base) und seine Ausrichtung (Rotation) angeben. Diese Attribute lassen sich leicht ändern, um beispielsweise das Objekt zu bewegen:

box.Placement
box.Placement.Base
box.Placement.Base = sumvec
 
otherpla = FreeCAD.Placement()
box.Placement = otherpla

Bevor wir weitermachen können, müssen Sie erst noch einige wichtige Konzepte verstehen.

App und GUI

FreeCAD wurde von Anfang an als Kommandozeilen-Anwendung konzipiert, d.h. ohne notwendige Benutzeroberfläche. Als Folge davon ist fast alles zwischen einer "geometrischen" Komponente und einer "visuellen" Komponente aufgeteilt. Wenn man im Kommandozeilenmodus arbeitet, dann ist der geometrische Teil vorhanden, aber der visuelle Teil deaktiviert. Fast jedes Objekt in FreeCAD besteht deshalb aus zwei Teilen, einem Object und einem ViewObject (Objektansicht).

Um dieses Konzept besser zu verstehen, sollten Sie sich das Würfel-Objekt genauer ansehen. Seine geometrischen Eigenschaften (Maße, Ort, usw.) sind im object gespeichert, während seine visuellen Eigenschaften (Farbe, Liniendicke, usw.) im viewobject enthalten sind. Diese Aufteilung entspricht den beiden Registerkarten "Daten" und "Ansicht" in der Combo-Ansicht. Das viewobject eines Objektes kann wie folgt angesprochen werden:

vo = box.ViewObject

Damit lassen sich auch die Eigenschaften der Registerkarte "Ansicht" ändern:

vo.Transparency = 80
vo.hide()
vo.show()

Wenn Sie FreeCAD starten, dann lädt die Python-Konsole automatisch die beiden Module FreeCAD und FreeCADGui (die in der Konsole auch über ihre Abkürzungen App und Gui angesprochen werden können). Sie enthalten allerlei allgemeine Funktionen zum Arbeiten mit Dokumenten und Objekten. Um unser Konzept zu illustrieren, beachten Sie, dass sowohl FreeCAD als auch FreeCADGui ein Attribut namens ActiveDocument enthalten, das das momentan geöffnete Dokument angibt. Dabei sind FreeCAD.ActiveDocument and FreeCADGui.ActiveDocument jedoch nicht dasselbe Objekt. Sie sind stattdessen zwei Komponenten eines FreeCAD-Dokumentes, die verschiedene Attribute und Methoden enthalten. Beispielsweise enthält nur FreeCADGui.ActiveDocument eine Eigenschaft namens ActiveView, die die momentan geöffnete 3D-Ansicht beschreibt.

Module

Nun fragen Sie sich vielleicht, was man außer "Part::Box" sonst noch tun kann? Die Basisanwendung von FreeCAD ist mehr oder weniger ein leerer Container. Ohne die dazugehörigen Module kann man kaum mehr machen als Dokumente zu öffnen. Die wahre Stärke von FreeCAD liegt in seinen Modulen. Jedes davon fügt nicht nur einen neuen Arbeitsbereich in die Benutzeroberfläche ein, sondern auch neue Python-Befehle und neue Objekttypen. Als Folge davon können viele verschiedene und sogar zueinander inkompatible Objekte im selben Dokument koexistieren. Die wichtigsten Module von FreeCAD werden wir uns im weiteren Verlauf des Tutorials ansehen, d.h. die Module Part, Mesh, Sketcher und Draft.

Die Module Sketcher und Draft nutzen beide das Modul Part, um Geometrien zu erzeugen und zu handhaben, während das Modul Mesh vollkommen unabhängig ist und seine eigenen Objekte verwaltet. Mehr darüber folgt weiter unten.

Man kann sich alle für das aktuelle Dokument verfügbaren Basisobjekttypen folgendermaßen anzeigen lassen:

doc.supportedTypes()

Die verschiedenen FreeCAD Module werden nicht automatisch in der Python-Konsole geladen, obwohl ihre Objekttypen zu FreeCAD hinzugefügt werden. Der Grund dafür ist, dass auf diesem Wege der Programmstart beschleinigt wird. Module werden immer nur geladen, wenn man sie benötigt. Die Inhalte eines Moduls lassen sich wie folgt betrachten:

import Part
Part.

Wir werden unten mehr über das Modul Part lernen.

Mittlerweile sollten Sie etwas mehr über die verschiedenen Module von FreeCAD wissen: Die Kernmodule (FreeCAD, FreeCADGui) und die Arbeitsbereichmodule (Part, Mesh, Sketcher). Weitere wichtige Module sind das 3D-Szenenmodul (pivy) und das Schnittstellenmodul (pyside), die wir weiter unten behandeln werden.

Nun ist es an der Zeit, die wichtigeren Arbeitsbereichmodule etwas tiefgehender zu erkunden.

Mesh

Polygonnetze (engl. Mesh) sind eine einfache Art von 3D-Objekten, wie sie z.B. in den Sketchup, Blender oder 3ds Max verwendet werden. Sie bestehen aus drei Komponenten: Punkte ("vertices"), Linien ("edges") und Oberflächen. In vielen Anwendungen, u.a. FreeCAD, können Oberflächen nur 3 vertices besitzen. Aber nichts hält Sie davon ab, eine größere Fläche aus nebeneinander liegenden Dreiecksflächen zu erstellen.

Polygonnetze sind sehr einfache Objekte, was auch Nachteile haben kann, aber für viele Anwendungen überwiegen die Vorteile, sodass man wegen ihrer Einfachheit Millionen davon in einem Dokument speichern kann. In FreeCAD hingegen, sind sie weniger bedeutend und werden vor allem beim Importieren von Objekten aus anderen Dateiformaten (.stl, .obj) verwendet. Sie wurden außerdem in der Anfangszeit von FreeCAD intensiv für Testzwecke verwendet.

Polygonnetz-Objekte und FreeCAD-Objekte sind zwei verschiedene Dinge. Man kann das FreeCAD-Objekt als einen Container für Polygonnetz-Objekte ansehen. Um also ein Mesh-Objekt in FreeCAD hinzuzufügen, müssen wir erst ein FreeCAD-Objekt und eine Mesh-Objekt erstellen und dann das Mesh-Objekt in das FreeCAD-Objekt einfügen:

import Mesh
mymesh = Mesh.createSphere()
mymesh.
mymesh.Facets
mymesh.Points
 
meshobj = doc.addObject("Mesh::Feature","MyMesh")
meshobj.Mesh = mymesh
doc.recompute()

Dies ist ein Standardbeispiel, das die Methode createSphere() nutzt, um eine Kugel zu erzeugen, aber man kann natürlich auch individuelle Polygonnetze konstruieren, indem man ihre "vertices" und "faces" selbst definiert.

Read more about mesh scripting...

Part

Das Modul Part ist das leistungsstärkste Modul in FreeCAD. Es erlaubt das Erstellen und Bearbeiten von BRep-Objekten. Diese Objekte können, im Gegensatz zu Polygonnetzen (Meshes), eine größere Anzahl an Komponenten besitzen. Der Term "Brep" steht dabei für Boundary Representation, was bedeutet, dass diese Objekte durch ihre Oberflächen definiert werden, die wiederum ein geschlossenes Volumen definieren. Die Oberflächen können dabei auf vielfältige Weise definiert werden, z.B. durch ebene Flächen oder auch durch komplexe NURBS-Oberflächen. Sie enthalten zudem das Konzept eines Volumens.

Das Part-Modul basiert auf der leistungsstarken Bibliothek OpenCasCade, die eine Vielzahl komplexer Operationen auf Objekten erlaubt.Beispiel dafür sind Boolsche Operationen, Abrundungen, usw.

Das Part-Modul arbeitet auf dieselbe Weise wie das Mesh-Modul: Man erstellt ein FreeCAD-Objekt und ein Part-Objekt, danach fügt man das Part-Objekt in das FreeCAD-Objekt ein:

import Part
myshape = Part.makeSphere(10)
myshape.
myshape.Volume
myshape.Area

shapeobj = doc.addObject("Part::Feature","MyShape")
shapeobj.Shape = myshape
doc.recompute()

Das Part-Module besitzt ebenso wie das Mesh-Modul eine Abkürzung zum Erzeugen von FreeCAD-Objekten und Einfügen von Formen in dieses Objekt, sodass die letzten drei Zeilen des vorherigen Absatzes übersprungen werden können:

Part.show(myshape)

Beim Untersuchen der Inhalte von myshape werden Sie feststellen, dass viele interessante Komponenten wie Flächen, Kanten, Eckpunkte, Volumenkörper oder Hüllkörper vorhanden sind. Weiterhin findet man geometrische Operationen wie Ausschneiden (Subtraktion), Vereinigung (Union) und Schnitt (Intersektion). Die Seite Topological data scripting beschreibt diese Zusammenhänge im Detail.

Read more about part scripting...

Draft

FreeCAD enthält viele weitere Module, wie Sketcher oder Draft, die ebenfalls Part-Objekte erzeugen, aber ihnen weitere Parameter mitgeben oder die Handhabung der Geometrie auf andere Weise lösen. Unser obiges Würfelbeispiel ist ein perfektes Beispiel eines parametrischen Objektes. Zum Definieren des Würfels müssen nur ein paar Parameter, wie Höhe, Breite und Länge, festgelegt werden. Darauf aufbauend wird das Objekt automatisch seine Form und Darstellung als Part-Objekt berechnen. FreeCAD erlaubt es Ihnen, solche Objekte mit Python zu erstellen.

Das Modul Draft fügt einige zweidimensionale, parametrische Objekttypen hinzu (die ebenfalls Part-Objekte sind), wie z.B. Linien und Kreise, und bietet zudem einige Funktionen, die nicht nur auf mit Draft erstellte Objekte anwendbar sind, sondern auch auf Part-Objekte. Um diese Möglichkeit zu untersuchen, sollten Sie folgendes eingeben:

import Draft
Draft.
rec = Draft.makeRectangle(5,2)
mvec = FreeCAD.Vector(4,4,0)
Draft.move(rec,mvec)
Draft.move(box,mvec)

Benutzeroberfläche (Interface)

Die Benutzeroberfläche von FreeCAD wurde mit der leistungsstarken Grafikbibliothek Qt entwickelt, die hierbei für das Zeichnen und Verwalten der Schaltflächen, Menüs, Werkzeugleisten usw. zuständig ist. Die Bibliothek Qt stellt ein Modul namens PySide zur Verfügung, das den Zugriff und die Bearbeitung von Qt-Schnittstellen, wie in FreeCAD, ermöglicht. Dies probieren wir nun aus, indem wir ein einfaches Dialogfenster erzeugen:

from PySide import QtGui
QtGui.QMessageBox.information(None,"Apollo program","Houston, we have a problem")

Das erscheinende Dialogfenster hat das FreeCAD-Icon in der Titelleiste, d.h. Qt weiß, dass der Aufruf innerhalb von FreeCAD stattfand. Damit können wir alle Bereiche der Benutzeroberfläche von FreeCAD auf einfache Art und Weise verändern.

Qt ist ein sehr leistungsfähige Benutzeroberfläche, mit der man sehr komplexe Dinge machen kann. Sie hat aber auch eine Reihe von einfach zu benutzenden Werkzeugen wie den Qt-Designer. Hiermit kann man Dialoge grafisch entwerfen und sie der FreeCAD-Oberfläche mit ein paar Zeilen Pythoncode hinzufügen.

Erfahre hier mehr über PySide...

Makros

Nachdem wir nun Grundlagen verstanden haben, kommt als nächstes, wie wir Pythonscripte erhalten und sie von der FreeCAD aus starten können. Dafür gibt es einfache Mechanismen genannt Macros/de. Ein Makro ist ein einfaches Pythonscript, das der Werkzeugleiste hinzugefügt werden kann und mit einem einfachen Mausklick gestartet werden kann. FreeCAD stellt dafür einen einfachen Texteditor (Makro -> Makros -> Create) zur Verfügung, mit dem man Scripte schreiben oder einfach einfügen Button festzulegen, der der Werkzeugleiste hinzugefügt werden kann.

Jetzt bist Du bereit für mehr tiefergehenderes FreeCAD-Scripting. Weiter geht's zum Power users hub/de!